Index: funcs/func_math.c
===================================================================
--- funcs/func_math.c	(revision 75977)
+++ funcs/func_math.c	(working copy)
@@ -73,6 +73,7 @@
 	char *op;
 	int iaction=-1;
 	int type_of_result=FLOAT_RESULT;
+	int negvalue1 = 0;
 
 	/* dunno, big calulations :D */
 	char user_result[30];
@@ -93,14 +94,13 @@
 	}
 
 	mvalue1 = argv[0];
-	
-	if ((op = strchr(mvalue1, '+'))) {
-		iaction = ADDFUNCTION;
-		*op = '\0';
-	} else if ((op = strchr(mvalue1, '-'))) {
-		iaction = SUBTRACTFUNCTION;
-		*op = '\0';
-	} else if ((op = strchr(mvalue1, '*'))) {
+
+	if (mvalue1[0] == '-') {
+		negvalue1 = 1;
+		mvalue1++;
+	}
+
+	if ((op = strchr(mvalue1, '*'))) {
 		iaction = MULTIPLYFUNCTION;
 		*op = '\0';
 	} else if ((op = strchr(mvalue1, '/'))) {
@@ -130,7 +130,13 @@
 			iaction = EQFUNCTION;
 		} else
 			op = NULL;
-	} 
+	} else if ((op = strchr(mvalue1, '+'))) {
+		iaction = ADDFUNCTION;
+		*op = '\0';
+	} else if ((op = strchr(mvalue1, '-'))) { /* subtraction MUST always be last, in case we have a negative first number */
+		iaction = SUBTRACTFUNCTION;
+		*op = '\0';
+	}
 	
 	if (op) 
 		mvalue2 = op + 1;
@@ -169,6 +175,9 @@
 		return NULL;
 	}
 
+	if (negvalue1)
+		fnum1 = 0 - fnum1;
+
 	switch (iaction) {
 	case ADDFUNCTION :
 		ftmp = fnum1 + fnum2;
